/*
 * Licensed Material - Property of IBM
 * (C) Copyright IBM Corp. 2016 - All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 */

/**
 * This function is used for the Rational Application Developer (RAD) IDE -
 * Jasmine integration to gather the results from runs. DO NOT REMOVE IT,
 * otherwise the product won't be able to collect the unit test data.
 * 
 * This reporter is intended to collect unit test runs for workbench integration.
 * If this reporter is running outside of RAD context, then will delegate the
 * reporting work to the default Jasmine reporter. If no default reporter is
 * found then there will be no results.
 */
jasmineRequire.RADReporter = function() {
	
	function RADReporter() {

		this.jasmineStarted = function(suiteInfo) {
			passTestResultsRAD(suiteInfo);
		};

		this.suiteStarted = function(result) {
			passTestResultsRAD(result);
		};

		this.specStarted = function(result) {
			passTestResultsRAD(result);
		};

		this.specDone = function(result) {
			passTestResultsRAD(result);
		};

		this.suiteDone = function(result) {
			passTestResultsRAD(result);
		};

		this.jasmineDone = function(result) {
			doneTestingNotifyRAD(result);
		};
	}

	function passTestResultsRAD(result) {

		if (typeof(captureUTResults) === "function") {
			var stringified = JSON.stringify(result);
			captureUTResults(stringified);
		}
	}

	function doneTestingNotifyRAD(result) {

		if (typeof(radUnitTestDone) === "function") {
			radUnitTestDone(result);
		}
	}
	
	return RADReporter;
}();